#include <stdio.h>
#define MAX 1000*1000
#define DBG(x) 
int m[MAX];
int a[MAX];
char color[MAX];
char en[MAX];
int et[MAX][4];
void ADDE(int from,int to)
{
  if ((from != -1) && (to != -1))
    et[from][en[from]++] = to;
}
void getmax(int from)
{
  int i,j;
  int k,l;
  int depth=0;
  int diam=0, diam2=0;
  color[from] = 1;
  for (i = 0; i < en[from]; i++)
  {
    k = et[from][i];
    if (!color[k])
    {
      getmax(k);
      if (a[k]>diam)
        diam = a[k];
      if (m[k]+1>depth)
        depth = m[k]+1;
    }
  }
  for (i = 0; i < en[from]; i++)
  {
    k = et[from][i]; 
    for (j = 0; j < i; j++)
    {
      l = et[from][j];
      if ((color[k] == 2) && (color[l] == 2) && (m[k]+m[l]+2 > diam2) )
        diam2 = m[k]+m[l]+2;
    }  
  }
 /* DBG(printf("from max, res %d %d %d\n",from,max,res);) */
  m[from] = depth;
  diam = diam > depth ? diam : depth; 
  a[from] = diam2 > diam ? diam2 : diam;
  color[from] = 2;
}

int main(int argv,char **argc)
{
  int N,iN;
  scanf("%d",&N);
  for (iN = 0; iN < N; iN++)
  {
    int R,C;
    int r;
    int n;
    int j;
    char str[2000];
    int code[2000];
    int pcode[2000];
    scanf("%d %d",&R,&C);
    for (j = 0; j <= C+1; j++)
      pcode[j] = -1;
    n = 0;
    for (r = 0; r < R; r++)
    {
      code[0] = -1;
      code[C+1] = -1;
      scanf("%s",str);
      for (j = 1; j <= C; j++)
      {
        if (str[j-1] == '.')
        {
           en[n] = 0;
           color[n] = 0;
           code[j] = n++;
        }
        else
          code[j] = -1;
      }
      for (j = 1; j <= C; j++)
      {
        ADDE(code[j],code[j+1]);
        ADDE(code[j],code[j-1]);
        ADDE(code[j],pcode[j]);
        ADDE(pcode[j],code[j]);
      }
      for (j = 0; j <= C+1; j++)
        pcode[j] = code[j];
    }
    getmax(0);
    printf("Maximum rope length is %d.\n",a[0]);     
  }
  return 0;
}